import { AxiosRequestConfig } from 'axios';
import { GraphQLError } from 'graphql';
export declare type SendRequestFunction = <R extends object, V extends object = object>(query: string, variables?: V) => Promise<R>;
export declare class JgqlError extends Error {
    private _graphQLErrors;
    private _responseError;
    private _errorMessage;
    constructor(errorData: any);
    readonly type: "GRAPHQL" | "RESPONSE" | "STRING" | "REQUEST";
    readonly graphQLErrors: GraphQLError[] | null;
    readonly responseError: {
        status: number;
        data: string;
    } | null;
    toString(): string;
}
export interface Params {
    getUrl: () => string;
    augmentRequest?: (request: AxiosRequestConfig) => AxiosRequestConfig | Promise<AxiosRequestConfig>;
    processResponse?: (response: any) => any | Promise<any>;
    processError?: (error: JgqlError) => any | Promise<any>;
}
export declare const createSendRequestFunction: ({ getUrl, augmentRequest, processResponse, processError, }: Params) => SendRequestFunction;
